#!/usr/local/bin/php
<?
/********************************************************
 *                                                      *
 *                  Programa Principal                  *
 *                                                      *
 ********************************************************/

require_once('parametros.php');
require_once('Log.php');
require_once('Memoria.php');
require_once('PC.php');

if(count($argv) > 2)
	$arch=$argv[1];
else
$arch=$archivoExpPrevia;


$LTM= new Memoria();
$LTM->Load($arch,$nivel_reporte);
if(file_exists($archivoExpResueltos))
	$LTM->Load($archivoExpResueltos);
//Leer problemas
if(count($argv) > 2)
	$arch=$argv[2];
else
$arch=$argv[1];
$problemas=leeProblemasDeArchivo($arch);
//$memoria=print_r($LTM,true);
$memoria=$LTM->_print();
//$Log->GMem($LTM->_print());
file_put_contents('memoria.txt',$memoria);

foreach($problemas as $problema)
{
	//print "Resuelve\n";
	$probOrig['contexto']=clone $problema['contexto'];
	if($problema['define'])
		$probOrig['define']=clone $problema['define'];
	$solucion=resuelve($problema['contexto'],$LTM,$nivel_reporte);
	//aqui es donde agregamos la solucion a $archivoExpPrevia
	//pero faltaria ver si se pudo resolver.
	//si se pudo resolver
	//agregamos esto al archivo de experiencia y a la LTM.
	agregaExp($probOrig,$solucion);
	$probOrig['contexto']->_print(true);
	foreach($solucion as $paso)
		{
			$paso->_print(true);
		}
}
$Log->_print();
$memoria=$LTM->_print();
file_put_contents('memoria2.txt',$memoria);

function agregaExp($prob,$sol)
{//funcin que agrega la experiencia previa a LTM y al archivo de Experiencia Previa
	global $LTM,$archivoExpResueltos;
	//agregamos esta solucin a la LTM
	$LTM->add(clone $prob['contexto'],$sol,$prob['define']);
	//ahora generamos el xml de esta solucin
	$doc=new domDocument('1.0');
	$root='';
	$yaExiste=file_exists($archivoExpResueltos);
	if($yaExiste)
		{
			$doc->load($archivoExpResueltos);
			$root=$doc->documentElement;
		}
	else
		{
			$root=$doc->createElement('experiencia');
			$root=$doc->appendChild($root);
		}
	$xsol=$doc->createElement('solucion');
	$xsol=$root->appendChild($xsol);
	$prob['contexto']->xml($doc,$xsol);
	if($prob['define'])
		$prob['define']->xml($doc,$xsol);
	$xpasos=$doc->createElement('pasos');
	$xpasos=$xsol->appendChild($xpasos);
	foreach($sol as $p)
		{
			$p->xml($doc,$xpasos);
		}
	//finalmente escribimos este xml al archivo
	file_put_contents($archivoExpResueltos,beautyXml($doc->savexml()));
		
}

function beautyXml($xmldoc)
{
	$res=preg_replace('/></',">\n<",$xmldoc);
	return $res;
}
?>