<?
/********************************************************
 *                                                      *
 *                      Engagement                      *
 *                                                      *
 ********************************************************/
require_once('parametros.php');

function Engagement($problema,$mem,&$pasos,$historia)
{
  global $matchB1,$matchB2,$matchB3,$matchB4,$factorFalloB,$nivel_reporte;
	print "--- Engagement\n";
  $encontrada=false;
  $busquedas=array(1=>'basica',
									 2=>'cadaDesconocido',
									 3=>'cadaInsatisfecha',
									 4=>'porConocidos');
  $matchs=array(1=>$matchB1,
								2=>$matchB2,
								3=>$matchB3,
								4=>$matchB4);
  for($i=1;$i<=4 and !$encontrada;$i++)
    {
      $busqueda=$busquedas[$i];
      print "$busqueda\n";
      $acciones=$busqueda($problema,$matchs[$i],$mem);
      //print_r($acciones);
      $acciones=$historia->reduceAcciones(clone $problema,$acciones); //quita las acciones que no pueden repetirse
      //print_r($acciones);
      $cuantas=count($acciones);
      if($cuantas)//si hay acciones disponibles
				{
					$idx=rand(1,$cuantas) - 1; //se elige una accin al azar
					$accion=$acciones[$idx];
					$historia->addPaso($problema,$accion);
					$historia->addToSol($accion[0]);
					$accion[0]->postcondicion($problema);
					$encontrada=true;
					$pasos[]=$accion[0];
					if($nivel_reporte)
						{
							print "Se encontr la accin:\n";
							$accion[0]->_print(true);
							//print_r($problema);
							print "--\n";
						}
				}
    }
  return !$encontrada;
}
function basica($problema,$match,$mem,$Porig=null)
{  //bsqueda bsica
	global $factorFalloB,$nivel_reporte;
	$problema->_print(true);
	print "busca con exactamente este contexto\n";
	$acciones=$mem->getAsoc($problema,'e',$match,$Porig);
	//print_r($acciones);
  $cuantas=count($acciones);
	if($cuantas)
		{
			//$elegida=$acciones[rand(0,$cuantas-1)]; 
			return $acciones;
				//return $elegida;
		}
	print "bsqueda donde este problema est incluido\n";
	$match*=$factorFalloB;
	$acciones=$mem->getAsoc($problema,'i',$match,$Porig);
  $cuantas=count($acciones);
	if($cuantas)
		{
			return $acciones;
		}
	//$acciones=$mem->getAsoc($problema,'d',$match*$factorFalloB);
	print "busca donde este problema tenga un margen de semejanza.\n";
	$acciones=$mem->getAsoc($problema,'d',$match,$Porig);
	return $acciones;
	//}
  //return null;
}

function cadaDesconocido($problema,$match,$mem)
{
	$acciones=array();
	$desconocidos=$problema->getDesconocidos();
	if(count($desconocidos) > 1)
		{
			//Para cada desconocido hay que extraer la parte del contexto de que depende, es decir, las relaciones que lo involucran (sin involucrar otros desconocidos) y los objetos presentes en dichas relaciones.
			foreach($desconocidos as $desconocido)
				{
					$subproblema=$problema->subContexto($desconocido);
					$encontradas=basica($subproblema,$match,$mem,$problema);
					foreach($encontradas as $enc)
						$acciones[]=$enc;
				}
		}
	return $acciones;
}

function cadaInsatisfecha($problema,$match,$mem)
{
	$acciones=array();
	$insatisfechas=$problema->getInsatisfechas();
	//Para cada desconocido hay que extraer la parte del contexto de que depende, es decir, las relaciones que lo involucran (sin involucrar otros desconocidos) y los objetos presentes en dichas relaciones.
	foreach($insatisfechas as $insatisfecha)
		{
			$subproblema=$problema->subContexto($insatisfecha);
			$encontradas=basica($subproblema,$match,$mem,$problema);
			foreach($encontradas as $enc)
				$acciones[]=$enc;
		}
	return $acciones;
}

function porConocidos($problema,$match,$mem)
{
	$acciones=array();
	$subproblema=new Contexto($problema->getConocidos());
	$acciones=basica($subproblema,$match,$mem,$problema);
	return $acciones;
}


?>